/*
  ,        ,
      .       
  traf_engine.

*/

import xge_rx::*;

module rx_dir_resolver
#( 
  parameter DIR_CNT  = xge_rx::RX_DIR_CNT
)
(  
  input        pkt_rx_info_t             pkt_rx_stat_i,
  input                                  dir_cpu_wa_i,  
  output logic [DIR_CNT-1:0]             rx_dir_o
);

logic         req_dir_cpu;
logic         bad_pkt;





assign bad_pkt  = ( pkt_rx_stat_i.crc_err  ) || 
                  ( pkt_rx_stat_i.runt     ) || 
                  ( pkt_rx_stat_i.oversize );

            
assign  req_dir_cpu = ( pkt_rx_stat_i.broadcast || 
                        pkt_rx_stat_i.multicast || 
                        pkt_rx_stat_i.usercast    ) &&
                       !bad_pkt ;




always_comb
  begin
    rx_dir_o                = '0;
    rx_dir_o[RX_DIR_CPU]    =  ( req_dir_cpu && dir_cpu_wa_i );
    rx_dir_o[RX_DIR_DROP]   = ~( req_dir_cpu && dir_cpu_wa_i );
  end


endmodule
